/*---------------------------------------------------------------------------
      This code is part of the book
      LOGIC PROGRAMMING TECHNIQUES: THE PROLOG LANGUAGE
      Ilias Sakellariou, Nikos Bassiliades, Petros Kefalas, Demosthenes Stamatis
      Hellenic Academic On-line Publications, 2015
    ----------------------------------------------------------------------------*/
    


% ground_term/1
% ground_term(Term)
% True if Term is ground
% i.e. it does not have any free variables inside it
ground_term(Term) :-
	atomic(Term).		% an tomic term is ground
ground_term(Term):-
	nonvar(Term),		% if the term is nonvar (and not atomic) then it must be compound
	Term =.. [_Functor|Arguments],		% decompose it
	ground_aux(Arguments).			% and iterate over all is arguments to see if they are ground terms

ground_aux([]).
ground_aux([First|Rest]):-
	ground_term(First),
	ground_aux(Rest).
