/*---------------------------------------------------------------------------
      This code is part of the book
      LOGIC PROGRAMMING TECHNIQUES: THE PROLOG LANGUAGE
      Ilias Sakellariou, Nikos Bassiliades, Petros Kefalas, Demosthenes Stamatis
      Hellenic Academic On-line Publications, 2015
    ----------------------------------------------------------------------------*/
    

%%% neighbours1/2
%%% neighbours1(Country,)
%%% N is the number of neighbours for Country

neighbours1(_Country,_T) :-
	assert(counter(0)),    %   counter
	fail.                %    -    
neighbours1(Country,T) :-    %   
	next(Country,_X),      %    -       Country
	retract(counter(T)),    %     counter
	T1 is T + 1,        %     counter
	assert(counter(T1)),    %     counter - - 
	fail.                %    -     
neighbours1(_Country,T) :-    %     ,    
	retract(counter(T)).    %       counter

%%% next/2
%%% next(Country1,Country2)
%%% Country1 is neighbor with Country2
next(greece,turkey).	next(greece,albania).
next(greece,bulgaria).	next(greece,fyrom).
next(bulgaria,romania). next(bulgaria,serbia).
next(albania,serbia).


%%% neighbours2/2
%%% neighbours2(Country,)
%%% N is the number of neighbours for Country

neighbours2(Country,T) :-
	findall(N,next(Country,N),Neighbours),
	length(Neighbours,T).

%%% neighbours3/2
%%% neighbours3(Country,)
%%% N is the number of neighbours for Country

neighbours3(Country,T) :-
	bagof(N,next(Country,N),Neighbours),
	length(Neighbours,T).
