/*---------------------------------------------------------------------------
      This code is part of the book
      LOGIC PROGRAMMING TECHNIQUES: THE PROLOG LANGUAGE
      Ilias Sakellariou, Nikos Bassiliades, Petros Kefalas, Demosthenes Stamatis
      Hellenic Academic On-line Publications, 2015
    ----------------------------------------------------------------------------*/
    
% nth_member/3
% nth_member(N,E,L)
% E is the N-th element of list L

nth_member(1,E,[E|_]).		% The 1st element of a list with head E, is E
nth_member(N,E,[_|T]) :-	% In order to find the N-th element of a list
	nonvar(N),		% find the (N-1)-th element of its tail
	N > 1,			% When N is a know number reduce it by 1 until it becomes 1
	N1 is N - 1,
	nth_member(N1,E,T).
nth_member(N,E,[_|T]) :-	% When N is not known, find E in the tail of the list
	var(N),			% and count how many times the algorithm has recursed.
	nth_member(N1,E,T),
	N is N1 + 1.
