/*---------------------------------------------------------------------------
      This code is part of the book
      LOGIC PROGRAMMING TECHNIQUES: THE PROLOG LANGUAGE
      Ilias Sakellariou, Nikos Bassiliades, Petros Kefalas, Demosthenes Stamatis
      Hellenic Academic On-line Publications, 2015
    ----------------------------------------------------------------------------*/
    

%%% The student database
:- dynamic student/2.

%%% Run the main menu

run :-
	write('Main Menu:'), nl, nl,
	write('1 - Load a student table'), nl,
	write('2 - Save a student table'), nl,
	write('3 - Find a student grade'), nl,
	write('4 - Insert a student grade'), nl,
	write('5 - Delete a student grade'), nl,
	write('6 - Find how many student have passed'), nl,
	write('7 - Average Class Grade'), nl,
	write('8 - Print Student List (ordered)'), nl,
	write('0 - Exit'), nl, nl,
	write('Choice: '),
	read(Answer),
	do_on_choice(Answer).

%%% do_on_choice/1
%%% do_on_choice(N)
%%% Execute the Nth choice of the main menu

do_on_choice(1) :-
  !,   %      
  nl, write('File name: '), 
  read(File),             %      
  see(File),              %    
  repeat,                 %   
  read(Fact),             %     
  ins_fact(Fact),         %    
  Fact == end_of_file,
    %     repeat,    
  !,                      %    repeat
  nl, write('File loaded.'), nl,
  seen,                   %  
  run.                    %    ()

do_on_choice(2) :- !,
  write('File name: '), read(Name),
  tell(Name),                   %    
  save_facts,                   %   
  told,                         %  
  nl, write('File saved.'), nl,
  run.                          %    ()

do_on_choice(3) :- !,
  nl, write('Student Name: '),
  read(Name), nl,  			
  find_student(Name),    %       
  nl, run.

do_on_choice(4) :- !,
  nl, write('Student Name: '),
  read(Name), nl,      %     
  write('Grade: '),                   %    
  read(Grade), nl,
  insert_student(Name,Grade),         %    
  nl, run.

do_on_choice(5) :- !,
nl, write('Student Name: '),
read(Name), nl,                     %     
delete_student(Name),               %    
nl, run.

do_on_choice(6) :- !,                        %     
   findall(S,(student(S,G), G >= 5),L),      %     5     
   length(L,N),                              %     
   nl, write(N), write(' students have passed!'), 
   nl, nl, run.
   
do_on_choice(7) :- !,
   findall(G,student(_,G),L),    %         
   average_list(L,Avg),          %        
   nl, write('Course Average: '), 
   write(Avg), nl, nl,
   run.

do_on_choice(8) :- !,            %          
   setof(G-S,student(S,G),L),    %      ( )
   print_students(L),            %   
   nl, run.

do_on_choice(0) :- !,  %       
   nl, write('Goodbye!'), nl.

do_on_choice(_) :-     %      
   nl, write('Give a number between 0 and 8!'), nl,
   run.

%            
ins_fact(end_of_file) :- !.   %     
ins_fact(Fact) :- 
   assert(Fact).              %    

%          
save_facts :-
   student(Name,Grade),          %  -   
   write(student(Name,Grade)),   %   
   write('.'), nl,               %  ""
   fail.                         %      
save_facts.                      %     ,  

%        
find_student(Name) :-       %    ,     
   student(Name,Grade), !, 
   write('Grade: '),
   write(Grade), nl.
find_student(_) :-          %  ,    
   write('Not found!'), nl.

%       
insert_student(Name,Grade) :-  
   student(Name,_), !,                 %     (  )
   write(Student ), write(Name),     %   
   write( already exists!), nl.
insert_student(Name,Grade) :-  
   assert(student(Name,Grade)).        %  ,   


%    
delete_student(Name) :-                   %    ,  
   retract(student(Name,_)), !.           %   ( )
delete_student(_) :-                      %  ,    
   write('Not found!'), nl.

%%% average_list/2
%%% Average_list(List,Average)
%%%     Average    List

average_list([],No student in the DB!) :- !. %         ..
average_list(L,A) :-    %       
   sumlist(L,S),     %      
   length(L,N),      %     
   A is S / N.       %       

%%% print_students/1
%%% print_students(List)
%%%    List

print_students([]) :- nl.     %     -     
print_students([G-S|T]) :-    %     ()     
   write(S), write(' : '), 
   write(G), nl, 
   print_students(T).         %      




